#pragma comment(lib, "vfw32.lib")
#pragma comment(lib, "Shlwapi.lib")

#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <Windows.h>
#include <Shlwapi.h>
#include <tchar.h>
#include "Logger.hpp"
#include "WaveExtractor.hpp"

// R}hCIvV
const TCHAR* OPTIONS[] = {"help", "quit", "verbose", "debug", "stream-number"};

/**
 * wvbZ[W\
 */
void printUsage()
{
#ifdef _WIN64
	_tprintf(_T("avs2wav64  (version 1.0.1)\n"));
#else
	_tprintf(_T("avs2wav32  (version 1.0.1)\n"));
#endif
	_tprintf(_T("  Copyright(C) 2012 Takuya Kurosawa All Rights Reserved.\n\n"));
	_tprintf(_T("Usage:\n"));
#ifdef _WIN64
	_tprintf(_T("  avs2wav64 <IvV> ̓t@C <o̓t@C>\n\n"));
#else
	_tprintf(_T("  avs2wav32 <IvV> ̓t@C <o̓t@C>\n\n"));
#endif
	_tprintf(_T("  ̓t@C    AVSt@C\n"));
	_tprintf(_T("  o̓t@C    WAVEt@C(ȗ)\n"));
	_tprintf(_T("                  ȗꍇ͓̓t@C.wavǉpXgp\n"));
	_tprintf(_T("                  - w肷ƃt@CɏoWo͂ɏo͂\n\n"));
	_tprintf(_T("  IvV (ȗ)\n"));
	_tprintf(_T("    -h --help          wvbZ[W\\n"));
	_tprintf(_T("    -q --quit          bZ[Wo͂}\n"));
	_tprintf(_T("    -v --verbose       ڂbZ[Wo\n"));
	_tprintf(_T("    -d --debug         Jҗp̃bZ[Wo\n"));
	_tprintf(_T("    -s --stream-number 0Jnŏo͂Xg[ԍw肷 ftHg0\n"));
}


int _tmain(int argc, _TCHAR* argv[])
{
	// R}hC΃wvbZ[W\
	if (argc <= 1)
	{
		printUsage();
		return 0;
	}

	// ep[^̃ftHgl
	const TCHAR* inputFilePath = NULL;           // ̓t@CpX
	const TCHAR* outputFilePath = NULL;          // o̓t@CpX
	bool outputStdout = false;                   // o͂Wo͂
	DWORD streamNumber = 0;                      // Ώۂ̃I[fBIXg[ԍ
	Logger::Level level = Logger::Level::NORMAL; // Oo̓x

	// R}hC̓ǂݍ
	for (int i = 1; i < argc; ++i)
	{
		_TCHAR* argument = argv[i];
		if (argument[0] == _T('-'))
		{
			if (argument[1] == NULL)
			{
				if (inputFilePath != NULL && outputFilePath == NULL)
					outputStdout = true;
				else
				{
					_ftprintf(stderr, _T("o̓t@C - IvV͓Ɏwo܂B\n"), argument);
					return 1;
				}
			}
			else
			{
				int optionNumber = -1;
				for (int o = 0; o < 5; ++o)
				{
					if (argument[1] == _T('-') && _tcscmp(&argument[2], OPTIONS[o]) == 0)
					{
						optionNumber = o;
						break;
					}
					if (argument[2] == NULL && argument[1] == OPTIONS[o][0])
					{
						optionNumber = o;
						break;
					}
				}

				if (optionNumber == 0)
				{
					printUsage();
					return 0;
				}
				else if (optionNumber == 1)
				{
					if (level == Logger::Level::NORMAL)
						level = Logger::Level::QUIT;
				}
				else if (optionNumber == 2)
				{
					if (level < Logger::Level::VERBOS)
						level = Logger::Level::VERBOS;
				}
				else if (optionNumber == 3)
				{
					level = Logger::Level::DEBUG;
				}
				else if (optionNumber == 4)
				{
					if (i + 1 >= argc)
					{
						_ftprintf(stderr, _T("--stream-number(-s)IvV̒lw肵ĂB\n"), argument);
						return 1;
					}

					streamNumber = _ttoi(argv[++i]);
				}
				else
				{
					_ftprintf(stderr, _T("%s IvV͎gpł܂B\n"), argument);
					return 1;
				}
			}
		}
		else
		{
			if (inputFilePath == NULL)
				inputFilePath = argument;
			else
			{
				if (!outputStdout && outputFilePath == NULL)
					outputFilePath = argument;
				else
				{
					_ftprintf(stderr, _T("܂B(%s)\n"), argument);
					return 1;
				}
			}
		}
	}

	// p[^`FbN
	if (inputFilePath == NULL)
	{
		_ftprintf(stderr, _T("̓t@Cw肵ĂB\n"));
		return 1;
	}
	else if (!PathFileExists(inputFilePath))
	{
		_ftprintf(stderr, _T("̓t@C̃pXmFĂB\n"));
		return 1;
	}

	// o̓t@CpXw肳ċȂΓ̓t@CpX쐬
	TCHAR* outputFilePathBuffer = NULL;
	if (!outputStdout && outputFilePath == NULL)
	{
		size_t length = _tcslen(inputFilePath);
		outputFilePathBuffer = new TCHAR[length + 4 + 1];
		_tcscpy(outputFilePathBuffer, inputFilePath);
		_tcscpy(&outputFilePathBuffer[length], _T(".wav"));
		outputFilePathBuffer[length + 4] = 0; // Ô

		outputFilePath = outputFilePathBuffer;
	}

	// t@CWo͂ɏo͂ꍇ͕Wo͂oCi[hɐݒ肷
	if (outputStdout)
		_setmode(_fileno(stdout), _O_BINARY);

	// K[쐬
	Logger logger(level, !outputStdout);

	logger.verbos(_T("̓t@C: %s\n"), inputFilePath);
	if (outputFilePath == NULL)
		logger.verbos(_T("o̓t@C: Wo\n"));
	else
		logger.verbos(_T("o̓t@C: %s\n"), outputFilePath);
	logger.verbos(_T("ΏۃXg[ԍ: %d\n"), streamNumber);

	// s
	if (CoInitializeEx(NULL, COINIT_APARTMENTTHREADED) == S_OK)
	{
		WaveExtractor extractor(&logger);
		if (extractor.open(inputFilePath))
		{
			extractor.extract(streamNumber, outputFilePath);
			extractor.close();
		}
		CoUninitialize();
	}
	else
	{
		logger.error(_T("COM̏Ɏs܂B\n"));
	}

	if (outputFilePathBuffer != NULL)
		delete [] outputFilePathBuffer;

	return 0;
}